﻿using RadBookPdfViewerInMiddlePages.Models;
using System.Collections.ObjectModel;
using System.IO;
using System.Windows;
using System.Windows.Media;
using Telerik.Windows.Documents.Fixed.FormatProviders;
using Telerik.Windows.Documents.Fixed.FormatProviders.Pdf;
using Telerik.Windows.Documents.Fixed.Model;
using Telerik.Windows.Documents.Fixed.Model.Collections;

namespace RadBookPdfViewerInMiddlePages
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.documentStream = new FileStream("../../Resources/Sample.pdf", FileMode.Open);
            RadFixedDocument doc = new PdfFormatProvider(this.documentStream, FormatProviderSettings.ReadOnDemand).Import();
            
            var itemsSource = CreateItemsSource(doc.Pages);
            this.book.ItemsSource = itemsSource;
        }

        private static ObservableCollection<object> CreateItemsSource(PagesCollection pages)
        {
            var itemsSource = new ObservableCollection<object>();

            itemsSource.Add(new CoverItem { Header = "Front Cover", Background = Brushes.Beige });
            for (int i = 0; i < pages.Count; i++)
            {
                itemsSource.Add(pages[i]);
            }
            itemsSource.Add(new CoverItem { Header = "Back Cover", Background = Brushes.BurlyWood });
            return itemsSource;
        }

        private Stream documentStream;
    }
}
